﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
#Event: ItemClick (Clr As Int)
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private CustomListView1 As CustomListView
	Private ColorLabel As B4XView
	Private ColorPanel As B4XView
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Sleep(0) 'cannot load layouts in DesignerCreateView without calling Sleep before
	mBase.LoadLayout("listtemplate")
	CustomListView1.sv.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
	For Each line As String In File.ReadList(File.DirAssets, "colors.txt")
		Dim s() As String = Regex.Split(":", line)
		Dim Name As String = s(0)
		Dim Color As Int = Bit.Or(0xff000000, Bit.ParseInt(s(1), 16))
		Dim item As B4XView = xui.CreatePanel("")
		item.SetLayoutAnimated(0, 0, 0, mBase.Width, 50dip)
		CustomListView1.Add(item, Array(Name,Color))
	Next
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	If CustomListView1.IsInitialized Then
		CustomListView1.AsView.SetLayoutAnimated(0, 0, 0, Width, Height)
		CustomListView1.Base_Resize(Width, Height)
	End If
End Sub

'lazy creation of the items.
Private Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For i = Max(0, FirstIndex - 5) To Min(CustomListView1.Size - 1, LastIndex + 5)
		Dim p As B4XView = CustomListView1.GetPanel(i)
		If p.NumberOfViews = 0 Then
			p.LoadLayout("ListOfColors")
			Dim NameAndValue() As Object = CustomListView1.GetValue(i)
			ColorLabel.Text = NameAndValue(0)
			ColorPanel.Color = NameAndValue(1)
		End If
	Next
End Sub

Private Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	Dim v() As Object = Value
	CallSub2(mCallBack, mEventName & "_ItemClick", V(1))
End Sub